#define F_CPU 8000000   
#include <avr/io.h>
#include <stdlib.h>		// wird nur fr die Funktion "iota" bei der LCD-Ausgabe gebraucht.
#include <util/delay.h>
#include <avr/pgmspace.h>		//wird fr PROGMEM gebraucht
#include "LCD-Routines.h"
/*
info 
LED ist an PB0, Pin1 angeschlossen.


direkt angeschlossenes LCD mit Beleuchtung, 16 poliger Stecker
E		PC1, Pin22 
RS		PE0, Pin31

D4		PA4, Pin35
D5		PA5, Pin34
D6		PA6, Pin33
D7		PA7, Pin32


Version10:
Es soll das EEPROM 93AA86C_2.c hinzu kommen. Erster Test der Ansteuerung. 
Alle Adressen werden duchgezhlt und gleichzeitig 0...256 als Daten ins EEEPROM geschrieben.
Beim Lesen erscheint in jedem zweiten Durchlauf die Hlfte der Zahl, die zuvor geschrieben wurde.
*/

char s[10];		//Character-Array zur Ausgabe aufs LCD mittels ITOA
const char str0[] PROGMEM = "Programmversion Mega162_10.c";



// Hauptprogramm
int main(void) {

    uint16_t i = 0; 


	DDRB |= (1 << PB0) | (1 << PB1); //Ausgang fr LED und fr den PWM-Ausgang, an dem das Display 2 kHz bekommt, als Ausgang schalten.
	lcd_init();				//normales LCD am PORT initialisieren
	lcd_string("Mega162_zehnte"); 

	SPI_MasterInit();			//Ausgnge fr EEPROM einstellen
	EWEN_93AA86C();

	// Endlosschleife
    while (1) {

		PORTB ^= (1 << PB0);   	// LED toggeln PB0
		
		i++;
//auf das standard-LCD schreiben		

		lcd_setcursor( 2, 2 );	//Stelle / Zeile
//		ItoA_klein( i, s, 5);		//selbst geschriebenes ItoA mit Leerzeichen vorne dran, schreibt rechtsbndig mit fhrenden Leerzeichen!
		itoa( i, s, 5);		//selbst geschriebenes ItoA mit Leerzeichen vorne dran, schreibt rechtsbndig mit fhrenden Leerzeichen!
		lcd_string( s );	

	//	EWEN_93AA86C();
	//	EWDS_93AA86C();
	//	WRITE_93AA86C(adresse, daten);
	//	WRITEALL_93AA86C(adresse, daten);
	//	READ_93AA86C(adresse);
	//	ERASE_93AA86C(adresse);

	//	EWEN_93AA86C();

		WRITE_93AA86C(i, 0xFF);	//
	//	WRITE_93AA86C(i,  55);			//liest 200 bei Adresse 32
	//	WRITE_93AA86C(32,  70);			//liest 200 bei Adresse 32
	//	ERASE_93AA86C(i);
	//	WRITE_93AA86C(i,  i & 0xFF );			//funktioniert, aber Ausgabe nach dem Lesen ist immer die halbe Zahl
	//	WRITE_93AA86C(0xAAAA,  i & 0xFF );		//138 = 10001010		nur untere 8-Bits als Daten
	//	ERAL_93AA86C();
	//	EWDS_93AA86C();
	
//		lcd_setcursor( 2, 3 );	//Stelle / Zeile

//		ItoA_klein( (READ_93AA86C(i) &  0xFF), s, 5);//selbst geschriebenes ItoA mit Leerzeichen vorne dran, schreibt rechtsbndig mit fhrenden Leerzeichen!
		itoa( (READ_93AA86C(i)), s, 5);//selbst geschriebenes ItoA mit Leerzeichen vorne dran, schreibt rechtsbndig mit fhrenden Leerzeichen!
		//(READ_93AA86C(i) &  0xFF) bringt positive Zahlen, aber immer die Hlfte der echten Zahl!!! 0...128
		//das unterste Bit fehlt also


	//	ItoA_klein( READ_93AA86C(i + 1), s, 5);		//selbst geschriebenes ItoA mit Leerzeichen vorne dran, schreibt rechtsbndig mit fhrenden Leerzeichen!
		lcd_setcursor( 2, 4 );	//Stelle / Zeile
		lcd_string( s );							//liest immer 138
		_delay_ms(200);
	//	if ( i == 130 ) i = 0;

/*
es scheint oberhalb von 32 immer 200 gelesen zu werden, auer wenn zuvor Eraseall dran war, dann ist es Null.

*/

    }   

    return 0;
}


